/*
 * SeaBattle-chat - programme de discussion entre deux ordinateurs
 *
 * le programme supporte les modes serveurs et clients
 * on le lance soit en mode listen, auquel cas il attend les connections
 * ou en mode connect [IP], auquel cas il se connecte �l'ip sp�ifi�
 *
 * Julien VEHENT - f�rier 2006 - julien@linuxwall.info
 */

/*! \file main.c
    \brief Fichier principal

	Le programme supporte les modes serveurs et clients.
	On le lance soit en mode listen, auquel cas il attend les connections ou en mode connect [IP], auquel cas il se connecte  l'ip spcifiee

    \Author D.Bernaudeau
    \Author J. Vehent
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>

#include "reseau.h"

/*!
  \def PORTSERVEUR
  \brief Port en coute pour le serveur
 */
#define PORTSERVEUR 1664

/*!
  \def MAXDATASIZE
  \brief Quantit max d'octets que l'on peut envoyer/recevoir
 */
#define MAXDATASIZE 1000

/*!
  \def BACKLOG
 */
#define BACKLOG 10

//! Fonction principale
/*!
  \param[in] argc est le nombre d'argement
  \param[in] argv est un tableau contenant les arguments
 */
int main(int argc, char *argv[]){
	
	
	/*! test du lancement du programme */
	if ((argc < 2)||((strcmp(argv[1],"connect")!=0)&&(strcmp(argv[1],"listen")!=0))) {
        	fprintf(stderr,"usage: SeaBattle <mode> \n");
		fprintf(stderr,"\nmode:\n\t1.Attente de connection: mode='listen'");
		fprintf(stderr,"\n\t2.connection: mode='connect [IP]'\n\n");
        	exit(1);
	}

	
	/*! un peu d'affichage */
	printf("\n\t#######################\n\t##### SeaBattle1.0 ####");
	printf("\n\t#######################\n\t#didier@bernaudeau.net#");
	printf("\n\t#julien@linuxwall.info#\n\t#######################\n\n");
	
	

	/*! Biffurcation: soit on passe en mode connection
	 * soit on passe en mode attente de connection
	 * strcmp compare deux chaines de caracteres 
	 * pour verifier si l'on as la chaine "connect" ou "listen"
	 * dans les arguments
	 */
	
	//!les programmes prennent galement en paramtres les identifiants de la mem partage
	if(strcmp(argv[1],"connect")==0) client(argv[2]);
	else if(strcmp(argv[1],"listen")==0) serveur();
	
	
	return 0;
}

