#ifndef _TEST_H_
#define _TEST_H_

//! Detecter  le chevauchement entre les bateaux
/*!
\sa set_collision()
\param matrice d'tat des cases
\param taille taille du bateau (=type)
\param x coordonne de la case
\param y coordonne de la case
\param orientation 0:horizontal 2:vertical
*/
int set_collision(int matrice[10][10], int taille, int x,int y, int orientation);


//! Detecter si le bateau sort de la grille
/*!
\sa sortie_matrice()
\param taille taille du bateau (=type)
\param x coordonne de la case
\param y coordonne de la case
\param orientation 0:horizontal 2:vertical
*/
int sortie_matrice(int taille, int x,int y, int orientation);

//! Vrifier si un bateau est coule et en modifie son tat
/*
\sa couler()
\param matrice d'tat des cases
\param ligne coordonne y de la case
\param colonne coordonne x de la case
\return identifiant du bateau coule ou 0 si ce n'est pas le cas
*/
int couler(int matrice[10][10], int ligne, int colonne);

//! Verifier si la partie est perdu
/*!
\sa perdu()
\param matrice d'tat des cases
\return 1:perdu 0:partie non terminee
*/
int perdu(int matrice[10][10]);

#endif
